-module(ex06).
-compile(export_all).
-import(arbre, [ arbreVide/0, arbreCons/3, racine/1, arbreGauche/1, arbreDroit/1, arbreEstVide/1, arbreEstFeuille/1 ]).

recherche( _, {arbre} )->
    false;
recherche( Elem, {arbre, Elem, _, _} ) ->
    true;
recherche( Elem, {arbre, _, Ag, Ad} ) ->
    recherche(Elem, Ag) orelse recherche(Elem, Ad).

rechercheTDA(Elem, Arbre) ->
    case arbreEstVide(Arbre) of
	true ->
	    false;
	false ->
	    case racine(Arbre) of 
		Elem ->
		    true ;
		_ ->
		    rechercheTDA(Elem, arbreGauche(Arbre)) orelse rechercheTDA(Elem, arbreDroit(Arbre))
	    end
    end.

rechercheOrd( _, {arbre} )->
    false;
rechercheOrd( Elem, {arbre, Elem, _, _} ) ->
    true;
rechercheOrd( Elem, {arbre, E, Ag, Ad} ) ->
    case Elem < E of
	true ->
	    rechercheOrd(Elem, Ag) ;
	false -> 
	    rechercheOrd(Elem, Ad)
    end.

nbNoeuds({arbre}) ->
    0 ;
nbNoeuds({arbre, _, Ag, Ad}) ->
    1 + nbNoeuds(Ag) + nbNoeuds(Ad).

hauteur({arbre}) ->
    0;
hauteur({arbre, _, Ag, Ad}) ->
    1 + max(hauteur(Ag), hauteur(Ad)).

somme({arbre}) ->
    0;
somme({arbre, Elem, Ag, Ad}) ->
    Elem + somme(Ag) + somme(Ad).

prefixe({arbre}) ->
    io:format("") ;
prefixe({arbre, Elem, Ag, Ad}) ->
    io:format("~B ", [ Elem ]),
    prefixe(Ag),
    prefixe(Ad).
    
infixe({arbre}) ->
    io:format("") ;
infixe({arbre, Elem, Ag, Ad}) ->
    infixe(Ag),
    io:format("~B ", [ Elem ]),
    infixe(Ad).
    
postfixe({arbre}) ->
    io:format("") ;
postfixe({arbre, Elem, Ag, Ad}) ->
    postfixe(Ag),
    postfixe(Ad),
    io:format("~B ", [ Elem ]).

bfs(Arbre) -> 
    bfsAlgo([ Arbre ]).

bfsAlgo([ ]) ->
    io:format("") ;
bfsAlgo([ {arbre} | Reste ]) ->
    io:format(""),
    bfsAlgo( Reste ) ;
bfsAlgo([ {arbre, Elem, Ag, Ad} | Reste ]) ->
    io:format("~B ", [ Elem ]),
    bfsAlgo( Reste ++ [ Ag , Ad ] ).

    

main() ->
    A = arbreCons(21, arbreCons(8, arbreVide(), arbreVide()), arbreVide()),
    B = arbreCons(7, arbreCons(29, arbreVide(), arbreVide()), arbreCons(13, arbreVide(), arbreCons(88, arbreVide(), arbreVide()))),
    C = arbreCons(5, arbreCons(12, A, arbreVide()), B),
    arbreEstVide(arbreVide()),
    arbreEstVide(C),
    arbreEstFeuille( arbreGauche(A) ),
    rechercheOrd(13, C),
    nbNoeuds(C),
    hauteur(C),
    somme(C),
    prefixe(C),
    io:format("\n"),
    infixe(C),
    io:format("\n"),
    postfixe(C),
    io:format("\n"),
    bfs(C).
